/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * gui-log.h: Itemized logger
 *
 * Copyright (C) 2000, 2001 Ximian, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _GUI_LOG_H
#define _GUI_LOG_H

#include <glib.h>
#include "gui.h"

#define GUI_TYPE_LOG                (gui_log_get_type())
#define GUI_LOG(obj)                (GTK_CHECK_CAST((obj), \
                                     GUI_TYPE_LOG, GUILog))
#define GUI_LOG_CLASS(klass)        (GTK_CHECK_CLASS_CAST((klass), \
                                     GUI_TYPE_LOG, GUILogClass))
#define GUI_IS_LOG(obj)             (GTK_CHECK_TYPE((obj), \
                                     GUI_TYPE_LOG))
#define GUI_IS_LOG_CLASS(klass)     (GTK_CHECK_CLASS_TYPE((klass), \
                                     GUI_TYPE_LOG))
#define GUI_LOG_GET_CLASS(obj)      (GUI_LOG_CLASS( \
                                     GTK_OBJECT(obj)->klass))

typedef struct _GUILog      GUILog;
typedef struct _GUILogClass GUILogClass;
typedef struct _GUILogPriv  GUILogPriv;

struct _GUILog {
    GtkObject parent;

    GUILogPriv *priv;
};

struct _GUILogClass {
    GtkObjectClass parent_class;

    /* Signals */
    void (*appended)(GUILog *log, char *message);
    void (*reset)(GUILog *log);
};

guint gui_log_get_type(void);
GUILog *gui_log_new(void);
void gui_log_reset(GUILog *log);
void gui_log_append(GUILog *log, char *message);
GSList *gui_log_get(GUILog *log);
char *gui_log_to_string(GUILog *log);

#endif /* _GUI_LOG_H */
